#if !defined(AFX_CLIENTSOCKET_H__57CCC730_F861_4654_9D70_F711F8835BD4__INCLUDED_)
#define AFX_CLIENTSOCKET_H__57CCC730_F861_4654_9D70_F711F8835BD4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ClientSocket.h : header file
//
class CServerSocket;


/////////////////////////////////////////////////////////////////////////////
// CClientSocket command target

class CClientSocket : public CSocket
{
// Attributes
public:
    struct creature
    {
        codewar::basic_creature data;
        codewar::attacked_by_info attacked;
        short last_turn_result;
        short next_turn_action;
    };
// Operations
public:
	CClientSocket(basic_arena &a, CServerSocket *p);
	virtual ~CClientSocket();
    codewar::server_handshake s_handshake;
    codewar::client_handshake c_handshake;
    codewar::creature_stats stats;
    basic_arena &arena;
    CServerSocket *parent;
    std::vector<creature> creatures;
// Overrides
public:
	void SendFeedback();
	bool ReceiveCreatureAction();
    void ComposeVisionInfo(codewar::basic_vision_info &v, int i);
	bool SendCreatureFeedback(int i);
	void Flush();
	bool ReceiveCreatureStats();
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClientSocket)
	public:
	virtual void OnConnect(int nErrorCode);
	virtual void OnReceive(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CClientSocket)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
protected:
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLIENTSOCKET_H__57CCC730_F861_4654_9D70_F711F8835BD4__INCLUDED_)
