// basic_arena.h: interface for the basic_arena class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASIC_ARENA_H__E8F81A89_4E70_477A_A173_3EB449E407A1__INCLUDED_)
#define AFX_BASIC_ARENA_H__E8F81A89_4E70_477A_A173_3EB449E407A1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../codewar.h"
#include <vector>

class basic_cell
{
public:
    basic_cell(short ct = codewar::cell_empty, short s = -1, short cr = -1):
      contents(ct), species(s), creature(cr){}
    short contents;
    short species;
    short creature;
};


class basic_arena  
{
public:
	basic_cell & get_relative_cell(int x, int y, short facing, int index);
	void randomize_walls();
	void dump();
	basic_arena(int h, int w);
	virtual ~basic_arena();
    std::vector<std::vector<basic_cell> > cells;
    
};

#endif // !defined(AFX_BASIC_ARENA_H__E8F81A89_4E70_477A_A173_3EB449E407A1__INCLUDED_)
